5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 .
"${source_path}/build/make/configure.sh"
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 --libc=PATH path to alternate libc
26 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
27 ${toggle_fast_unaligned} don't use unaligned accesses, even when
28 supported by hardware [auto]
29 ${toggle_codec_srcs} in/exclude codec library source code
30 ${toggle_debug_libs} in/exclude debug version of libraries
31 ${toggle_md5} support for output of checksum data
32 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
33 ${toggle_vp8} VP8 codec support
34 ${toggle_internal_stats} output of encoder internal stats for debug, if supported (encoders)
35 ${toggle_mem_tracker} track memory usage
36 ${toggle_postproc} postprocessing
37 ${toggle_multithread} multithreaded encoding and decoding.
38 ${toggle_spatial_resampling} spatial sampling (scaling) support
39 ${toggle_realtime_only} enable this option while building for real-time encoding
40 ${toggle_error_concealment} enable this option to get a decoder which is able to conceal losses
41 ${toggle_runtime_cpu_detect} runtime cpu detection
42 ${toggle_shared} shared library support
43 ${toggle_static} static library support
44 ${toggle_small} favor smaller size over speed
45 ${toggle_postproc_visualizer} macro block / block level visualizers
48 Codecs can be selectively enabled or disabled individually, or by family:
51 --disable-<codec>-encoder
52 --disable-<codec>-decoder
54 Codecs available in this distribution:
56 #restore editor state '
62 for c
in ${CODECS}; do
64 if [ "${family}" != "${last_family}" ]; then
65 [ -z "${str}" ] ||
echo "${str}"
66 str
="$(printf ' %10s:' ${family})"
68 str
="${str} $(printf '%10s' ${c#*_})"
76 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
79 # all_platforms is a list of all supported target platforms. Maintain
80 # alphabetically by architecture, generic-gnu last.
81 all_platforms
="${all_platforms} armv5te-linux-rvct"
82 all_platforms
="${all_platforms} armv5te-linux-gcc"
83 all_platforms
="${all_platforms} armv5te-none-rvct"
84 all_platforms
="${all_platforms} armv5te-symbian-gcc"
85 all_platforms
="${all_platforms} armv6-darwin-gcc"
86 all_platforms
="${all_platforms} armv6-linux-rvct"
87 all_platforms
="${all_platforms} armv6-linux-gcc"
88 all_platforms
="${all_platforms} armv6-none-rvct"
89 all_platforms
="${all_platforms} armv6-symbian-gcc"
90 all_platforms
="${all_platforms} iwmmxt-linux-rvct"
91 all_platforms
="${all_platforms} iwmmxt-linux-gcc"
92 all_platforms
="${all_platforms} iwmmxt2-linux-rvct"
93 all_platforms
="${all_platforms} iwmmxt2-linux-gcc"
94 all_platforms
="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
95 all_platforms
="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
96 all_platforms
="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
97 all_platforms
="${all_platforms} armv7-none-rvct" #neon Cortex-A8
98 all_platforms
="${all_platforms} mips32-linux-gcc"
99 all_platforms
="${all_platforms} ppc32-darwin8-gcc"
100 all_platforms
="${all_platforms} ppc32-darwin9-gcc"
101 all_platforms
="${all_platforms} ppc32-linux-gcc"
102 all_platforms
="${all_platforms} ppc64-darwin8-gcc"
103 all_platforms
="${all_platforms} ppc64-darwin9-gcc"
104 all_platforms
="${all_platforms} ppc64-linux-gcc"
105 all_platforms
="${all_platforms} sparc-solaris-gcc"
106 all_platforms
="${all_platforms} x86-darwin8-gcc"
107 all_platforms
="${all_platforms} x86-darwin8-icc"
108 all_platforms
="${all_platforms} x86-darwin9-gcc"
109 all_platforms
="${all_platforms} x86-darwin9-icc"
110 all_platforms
="${all_platforms} x86-linux-gcc"
111 all_platforms
="${all_platforms} x86-linux-icc"
112 all_platforms
="${all_platforms} x86-solaris-gcc"
113 all_platforms
="${all_platforms} x86-win32-gcc"
114 all_platforms
="${all_platforms} x86-win32-vs7"
115 all_platforms
="${all_platforms} x86-win32-vs8"
116 all_platforms
="${all_platforms} x86-win32-vs9"
117 all_platforms
="${all_platforms} x86_64-darwin9-gcc"
118 all_platforms
="${all_platforms} x86_64-darwin10-gcc"
119 all_platforms
="${all_platforms} x86_64-linux-gcc"
120 all_platforms
="${all_platforms} x86_64-linux-icc"
121 all_platforms
="${all_platforms} x86_64-solaris-gcc"
122 all_platforms
="${all_platforms} x86_64-win64-vs8"
123 all_platforms
="${all_platforms} x86_64-win64-vs9"
124 all_platforms
="${all_platforms} universal-darwin8-gcc"
125 all_platforms
="${all_platforms} universal-darwin9-gcc"
126 all_platforms
="${all_platforms} generic-gnu"
128 # all_targets is a list of all targets that can be configured
129 # note that these should be in dependency order for now.
130 all_targets
="libs examples docs"
132 # all targets available are enabled, by default.
133 for t
in ${all_targets}; do
134 [ -f ${source_path}/${t}.mk ] && enable ${t}
137 # check installed doxygen version
138 doxy_version
=$
(doxygen
--version 2>/dev
/null
)
139 doxy_major
=${doxy_version%%.*}
140 if [ ${doxy_major:-0} -ge 1 ]; then
141 doxy_version
=${doxy_version#*.}
142 doxy_minor
=${doxy_version%%.*}
143 doxy_patch
=${doxy_version##*.}
145 [ $doxy_major -gt 1 ] && enable doxygen
146 [ $doxy_minor -gt 5 ] && enable doxygen
147 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
150 # install everything except the sources, by default. sources will have
151 # to be enabled when doing dist builds, since that's no longer a common
153 enabled doxygen
&& php
-v >/dev
/null
2>&1 && enable install_docs
159 enable fast_unaligned
#allow unaligned accesses, if supported by hw
161 enable spatial_resampling
165 [ -d ${source_path}/..
/include
] && enable alt_tree_layout
167 [ -d ${source_path}/${d} ] && disable alt_tree_layout
;
170 if ! enabled alt_tree_layout
; then
171 # development environment
172 [ -d ${source_path}/vp8
] && CODECS
="${CODECS} vp8_encoder vp8_decoder"
174 # customer environment
175 [ -f ${source_path}/..
/include
/vpx
/vp8cx.h
] && CODECS
="${CODECS} vp8_encoder"
176 [ -f ${source_path}/..
/include
/vpx
/vp8dx.h
] && CODECS
="${CODECS} vp8_decoder"
178 [ -f ${source_path}/..
/lib
/*/*mt.lib
] && soft_enable static_msvcrt
181 CODECS
="$(echo ${CODECS} | tr ' ' '\n')"
182 CODEC_FAMILIES
="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
308 --disable-codecs) for c
in ${CODECS}; do disable
$c; done ;;
309 *) process_common_cmdline
"$opt"
315 post_process_cmdline
() {
318 # If the codec family is disabled, disable all components of that family.
319 # If the codec family is enabled, enable all components of that family.
320 log_echo
"Configuring selected codecs"
321 for c
in ${CODECS}; do
322 disabled
${c%%_*} && disable
${c}
323 enabled
${c%%_*} && enable ${c}
326 # Enable all detected codecs, if they haven't been disabled
327 for c
in ${CODECS}; do soft_enable
$c; done
329 # Enable the codec family if any component of that family is enabled
330 for c
in ${CODECS}; do
331 enabled
$c && enable ${c%_*}
334 # Set the {en,de}coders variable if any algorithm in that class is enabled
335 for c
in ${CODECS}; do
336 enabled
${c} && enable ${c##*_}s
342 enabled child || write_common_config_banner
343 enabled universal || write_common_target_config_h
${BUILD_PFX}vpx_config.h
345 # TODO: add host tools target (obj_int_extract, etc)
347 # For fat binaries, call configure recursively to configure for each
348 # binary architecture to be included.
349 if enabled universal
; then
350 # Call configure (ourselves) for each subarchitecture
351 for arch
in $fat_bin_archs; do
352 BUILD_PFX
=${arch}/ toolchain
=${arch} $self --child $cmdline_args ||
exit $?
356 # The write_common_config (config.mk) logic is deferred until after the
357 # recursive calls to configure complete, becuase we want our universal
358 # targets to be executed last.
359 write_common_config_targets
360 enabled universal
&& echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
362 # Calculate the default distribution name, based on the enabled features
365 for cf
in $CODEC_FAMILIES; do
366 if enabled
${cf}_encoder
&& enabled
${cf}_decoder
; then
367 DIST_DIR
="${DIST_DIR}-${cf}"
368 elif enabled
${cf}_encoder
; then
369 DIST_DIR
="${DIST_DIR}-${cf}cx"
370 elif enabled
${cf}_decoder
; then
371 DIST_DIR
="${DIST_DIR}-${cf}dx"
374 enabled debug_libs
&& DIST_DIR
="${DIST_DIR}-debug"
375 enabled codec_srcs
&& DIST_DIR
="${DIST_DIR}-src"
376 ! enabled postproc
&& DIST_DIR
="${DIST_DIR}-nopost"
377 ! enabled multithread
&& DIST_DIR
="${DIST_DIR}-nomt"
378 ! enabled install_docs
&& DIST_DIR
="${DIST_DIR}-nodocs"
379 DIST_DIR
="${DIST_DIR}-${tgt_isa}-${tgt_os}"
381 win
*) enabled static_msvcrt
&& DIST_DIR
="${DIST_DIR}mt" || DIST_DIR
="${DIST_DIR}md"
382 DIST_DIR
="${DIST_DIR}-${tgt_cc}"
385 if [ -f "${source_path}/build/make/version.sh" ]; then
386 local ver
=`"$source_path/build/make/version.sh" --bare $source_path`
387 DIST_DIR
="${DIST_DIR}-${ver}"
388 VERSION_STRING
=${ver}
390 VERSION_PATCH
=${ver##*.}
392 VERSION_MINOR
=${ver##*.}
394 VERSION_MAJOR
=${ver%.*}
396 enabled child ||
cat <<EOF >> config.mk
399 ifeq (\$(MAKECMDGOALS),dist)
400 DIST_DIR?=${DIST_DIR}
402 DIST_DIR?=\$(DESTDIR)${prefix}
404 LIBSUBDIR=${libdir##${prefix}/}
406 VERSION_STRING=${VERSION_STRING}
408 VERSION_MAJOR=${VERSION_MAJOR}
409 VERSION_MINOR=${VERSION_MINOR}
410 VERSION_PATCH=${VERSION_PATCH}
412 CONFIGURE_ARGS=${CONFIGURE_ARGS}
414 enabled child ||
echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
417 # Write makefiles for all enabled targets
419 for tgt
in libs examples docs solution
; do
420 local tgt_fn
="$tgt-$toolchain.mk"
422 if enabled
$tgt; then
423 echo "Creating makefiles for ${toolchain} ${tgt}"
424 write_common_target_config_mk
$tgt_fn ${BUILD_PFX}vpx_config.h
432 if enabled shared
; then
433 # Can only build shared libs on a subset of platforms. Doing this check
434 # here rather than at option parse time because the target auto-detect
435 # magic happens after the command line has been parsed.
436 enabled linux || die
"--enable-shared only supported on ELF for now"
438 if [ -z "$CC" ]; then
439 echo "Bypassing toolchain for environment detection."
440 enable external_build
442 log fake_check_header
"$@"
445 var
=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
454 [ -f "${d##-I}/$header" ] && result
=true
&& break
463 check_header stdio.h || die
"Unable to invoke compiler: ${CC} ${CFLAGS}"
464 check_ld
<<EOF || die "Toolchain is unable to link executables"
465 int main(void) {return 0;}
467 # check system headers
468 check_header stdint.h
469 check_header pthread.h
470 check_header sys
/mman.h
472 check_header vpx
/vpx_integer.h
-I${source_path} && enable vpx_ports
475 process_toolchain
() {
476 process_common_toolchain
478 # Handle universal binaries for this architecture
481 local darwin_ver
=${tgt_os##darwin}
482 fat_bin_archs
="$fat_bin_archs ppc32-${tgt_os}-gcc"
485 fat_bin_archs
="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
486 if [ $darwin_ver -gt 8 ]; then
487 fat_bin_archs
="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
493 # Enable some useful compiler flags
495 enabled werror
&& check_add_cflags
-Werror
496 check_add_cflags
-Wall
497 check_add_cflags
-Wdeclaration-after-statement
498 check_add_cflags
-Wdisabled-optimization
499 check_add_cflags
-Wpointer-arith
500 check_add_cflags
-Wtype-limits
501 check_add_cflags
-Wcast-qual
502 enabled extra_warnings || check_add_cflags
-Wno-unused-function
506 enabled werror
&& check_add_cflags
-Werror
507 check_add_cflags
-Wall
508 check_add_cflags
-Wpointer-arith
510 # ICC has a number of floating point optimizations that we disable
511 # in favor of deterministic output WRT to other compilers
512 add_cflags
-fp-model precise
515 # Enable extra, harmless warnings. These might provide additional insight
516 # to what the compiler is doing and why, but in general, but they shouldn't
517 # be treated as fatal, even if we're treating warnings as errors.
519 -Wdisabled-optimization
522 enabled gcc
&& EXTRA_WARNINGS
="${GCC_EXTRA_WARNINGS}"
523 RVCT_EXTRA_WARNINGS
="
526 enabled rvct
&& EXTRA_WARNINGS
="${RVCT_EXTRA_WARNINGS}"
527 if enabled extra_warnings
; then
528 for w
in ${EXTRA_WARNINGS}; do
529 check_add_cflags
${w}
530 enabled gcc
&& enabled werror
&& check_add_cflags
-Wno-error=${w}
534 # ccache only really works on gcc toolchains
535 enabled gcc || soft_disable ccache
536 if enabled mips
; then
537 enable dequant_tokens
541 # Enable the postbuild target if building for visual studio.
545 vs_version
=${tgt_cc##vs}
546 all_targets
="${all_targets} solution"
550 # Other toolchain specific defaults
551 case $toolchain in x86
*|ppc
*|universal
*) soft_enable postproc
;; esac
553 if enabled postproc_visualizer
; then
554 enabled postproc || die
"postproc_visualizer requires postproc to be enabled"
560 ## END APPLICATION SPECIFIC CONFIGURATION
564 cat <<EOF > ${BUILD_PFX}vpx_config.c
565 static const char* const cfg = "$CONFIGURE_ARGS";
566 const char *vpx_codec_build_config(void) {return cfg;}